-- #######################################
-- #######################################
-- LOCALS
-- #######################################
-- #######################################

local select, UnitBuff, UnitDebuff, UnitAura, tonumber, strfind, hooksecurefunc =
	select, UnitBuff, UnitDebuff, UnitAura, tonumber, strfind, hooksecurefunc

local function GoH_AddToolTipInfo(self,id,isItem)
	if GoHv5_DeathKnight_Data.config.Show_Tooltip_SpellIDs == "YES" then

		if isItem then
			self:AddLine("\n|cFF7070FFItem ID: "..id)
		else
			self:AddLine("\n|cFF7070FFSpell ID: "..id)
		end
		self:Show()

	end
end

-- #######################################
-- #######################################
-- SPELL HOOKS
-- #######################################
-- #######################################

hooksecurefunc(GameTooltip, "SetUnitBuff", function(self,...)
	if GoHv5_DeathKnight_Data.config.Show_Tooltip_SpellIDs == "YES" then

		local id = select(11,UnitBuff(...))
		if id then GoH_AddToolTipInfo(self,id) end

	end
end)

hooksecurefunc(GameTooltip, "SetUnitDebuff", function(self,...)
	if GoHv5_DeathKnight_Data.config.Show_Tooltip_SpellIDs == "YES" then

		local id = select(11,UnitDebuff(...))
		if id then GoH_AddToolTipInfo(self,id) end

	end
end)

hooksecurefunc(GameTooltip, "SetUnitAura", function(self,...)
	if GoHv5_DeathKnight_Data.config.Show_Tooltip_SpellIDs == "YES" then

		local id = select(11,UnitAura(...))
		if id then GoH_AddToolTipInfo(self,id) end
	end
end)

GameTooltip:HookScript("OnTooltipSetSpell", function(self)
	if GoHv5_DeathKnight_Data.config.Show_Tooltip_SpellIDs == "YES" then

		local id = select(3,self:GetSpell())
		if id then GoH_AddToolTipInfo(self,id) end

	end
end)

hooksecurefunc("SetItemRef", function(link, ...)
	if GoHv5_DeathKnight_Data.config.Show_Tooltip_SpellIDs == "YES" then

		local id = tonumber(link:match("spell:(%d+)"))
		if id then GoH_AddToolTipInfo(ItemRefTooltip,id) end

	end
end)

-- #######################################
-- #######################################
-- ITEM HOOKS
-- #######################################
-- #######################################

local function GoH_Add_SpellID(self)
	if GoHv5_DeathKnight_Data.config.Show_Tooltip_SpellIDs == "YES" then

		local link = select(2,self:GetItem())
		if not link then return end
		local id = select(3,strfind(link, "^|%x+|Hitem:(%-?%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%-?%d+):(%-?%d+)"))
		if id then GoH_AddToolTipInfo(self,id,true) end

	end
end

GameTooltip:HookScript("OnTooltipSetItem", GoH_Add_SpellID)
ItemRefTooltip:HookScript("OnTooltipSetItem", GoH_Add_SpellID)
ItemRefShoppingTooltip1:HookScript("OnTooltipSetItem", GoH_Add_SpellID)
ItemRefShoppingTooltip2:HookScript("OnTooltipSetItem", GoH_Add_SpellID)
ItemRefShoppingTooltip3:HookScript("OnTooltipSetItem", GoH_Add_SpellID)
ShoppingTooltip1:HookScript("OnTooltipSetItem", GoH_Add_SpellID)
ShoppingTooltip2:HookScript("OnTooltipSetItem", GoH_Add_SpellID)
ShoppingTooltip3:HookScript("OnTooltipSetItem", GoH_Add_SpellID)
